Subject: Re: [PATCH] DMA 4GB boundary protection

From: [email-masked] (Olof Johansson)
Date: Fri, 2 Mar 2007 16:27:48 -0600

On Fri, Mar 02, 2007 at 03:49:43PM -0600, Jake Moilanen wrote:
> There are many adapters which can not handle DMAing acrosss any 4 GB
> boundary.  For instance the latest Emulex adapters.  
> 
> This normally is not an issue as firmware gives us dma-windows under
> 4gigs.  However, some of the new System-P boxes have dma-windows above
> 4gigs, and this present a problem.
> 
> I propose fixing it in the IOMMU allocation instead of making each
> driver protect against it as it is more efficient, and won't require
> changing every driver which has not considered this issue.

Sorry, but you need to fix the drivers. They might be used on a system
without an IOMMU, or with direct mapping. It's particularily likely in
the case of DAC-capable devices, and that's the only case for which you
can cross a 4GB boundary in the first place.

-Olof